/*
        IcuKrell 2.0.0-pre0.1 - drJeckyll <drJeckyll@hotmail.com>
*/

#define CONFIG_NAME    "IcuKrell"
#define CONFIG_KEYWORD "icukrell"
#define STYLE_NAME     "icukrell"

#define ICUKRELL_VERSION_MAJOR 2
#define ICUKRELL_VERSION_MINOR 0
#define ICUKRELL_VERSION_REV   0
#define ICUKRELL_VERSION_STAGE "pre0.1"

#include <gkrellm2/gkrellm.h>

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdarg.h>
#include <errno.h>
#include <unistd.h>
#include <netinet/in.h>
#include <pwd.h>

#include "../config.h"
#include "options.h"
#include "action.h"
#include "themes.h"
#include "net.h"

#define STATUS_OFFLINE         0xffffffff
#define STATUS_ONLINE          0x00
#define STATUS_INVISIBLE       0x100
#define STATUS_NA_99A          0x04
#define STATUS_NA              0x05
#define STATUS_FREE_CHAT       0x20
#define STATUS_OCCUPIED_MAC    0x10
#define STATUS_OCCUPIED        0x11
#define STATUS_AWAY            0x01
#define STATUS_DND             0x13

#define NO_USERS		"0 Users    "
#define NO_USERS_SCROLL		"No Online users    "

#define ICU_NO_MSGS             "0"
#define ICU_DOWN                "ICU down"
#define ICU_OFFLINE             "Offline"
#define ICU_ONLINE              "Online"
#define ICU_INVISIBLE           "Invisible"
#define ICU_NA_99A              "N/A"
#define ICU_NA                  "N/A"
#define ICU_FREE_CHAT           "Free4Chat"
#define ICU_OCCUPIED_MAC        "Occupied"
#define ICU_OCCUPIED            "Occupied"
#define ICU_AWAY                "Away"
#define ICU_DND                 "DND"

/* popup menu */
GtkItemFactory *options_menu_factory(gint);

/* glabal vars */
GtkItemFactory *running_factory;
GtkItemFactory *not_running_factory;
gboolean icukrell_running, tmp_icukrell_running;
gchar *icukrell_theme_name;
struct sockaddr_un addr;

/* options */
gchar *icukrell_exec_command;
gint icukrell_auto_start;
gint icukrell_auto_hide;
gint online_users_panel;
gint online_panel_scroll_direction;
//gint misc_panel_visible;
gint auto_detect_ppp;
gint icukrell_blink_speed;
gint icukrell_scroll_speed;

/* pixmaps */
GdkPixmap *offline_pixmap;
GdkBitmap *offline_bitmap;
GdkPixmap *online_pixmap;
GdkBitmap *online_bitmap;
GdkPixmap *inv_pixmap;
GdkBitmap *inv_bitmap;
GdkPixmap *na_pixmap;
GdkBitmap *na_bitmap;
GdkPixmap *chat_pixmap;
GdkBitmap *chat_bitmap;
GdkPixmap *occ_pixmap;
GdkBitmap *occ_bitmap;
GdkPixmap *away_pixmap;
GdkBitmap *away_bitmap;
GdkPixmap *dnd_pixmap;
GdkBitmap *dnd_bitmap;
GdkPixmap *message_pixmap;
GdkBitmap *message_bitmap;
GdkPixmap *blank_pixmap;
GdkBitmap *blank_bitmap;

/* functions */
void destroy_plugin();
